import { Mind } from '../index';
export declare class Drag {
    private readonly options;
    private readonly cacheMap;
    private readonly root;
    private readonly dragNode;
    private readonly ignoreNodes;
    private temporaryLine;
    private readonly container;
    private readonly draggableLayout;
    constructor(context: {
        options: Required<Mind.Options>;
        cacheMap: Mind.CacheMap;
        root: Mind.Root;
        dragNode: Mind.Node;
        container: HTMLElement;
    });
    /**
     * 获取拖动节点插入到关联节点子代的下标
     * @param attachedNodeChildren 关联节点的子代
     * @param dropPosition 拖动节点镜像中心位置
     * @param dragNode 拖动节点
     * @param attachedNode 被关联的节点
     * @return 期望插入位置
     */
    calcDropIndex: (attachedNodeChildren: Mind.Node[] | undefined, dropPosition: Mind.Coordinate, dragNode: Mind.Node, attachedNode: Mind.Node) => number;
    /**
     * 拖动操作
     * - 根节点不可拖拽
     * @param position 拖动节点镜像中心位置
     * @param canBeAttachedNodes 需要搜索的可关联节点
     * @return 链接关联信息
     */
    drag: (position: Mind.Coordinate, canBeAttachedNodes: Mind.Node[]) => {
        attach: Mind.Node;
        orientation: Mind.Orientation;
    } | undefined;
    /**
     * 通知控制器拖动操作结束
     */
    end: () => void;
}
